# GNU GPL

import re
import os
import sys

CONFIG_FILE=sys.prefix+"/etc/pyxmame/pyxmamerc"
HOME_FILE=os.environ['HOME']+"/.pyxmame/pyxmamerc"

# read and write the config file
class Config(dict):

    def __init__(self):
        self.error=self.print_error
        return

    def read(self):
        if os.access(CONFIG_FILE,os.R_OK):
            self.readfile(CONFIG_FILE)
        if os.access(HOME_FILE,os.R_OK):
            self.readfile(HOME_FILE)
        return
        
    def readfile(self,filename):
        if not os.access(filename,os.R_OK):
            self.error("Can not access to %s file" % filename)
        fo=file(filename,"r")
        self.lines=fo.readlines()
        fo.close()
        
        rx=re.compile("^\s*(?P<tag>\w+)\s*:(?P<value>.+)$",re.I)
        for line in self.lines:
            if line[0] != "#" and line[0] != ";":
                match=rx.search(line)
                if match != None:
                    tag=   match.group("tag").strip()
                    value= match.group("value").strip()
                    if value[0] in  ('(','{',"'",'"',"["):
                        self[tag]=eval(value)
                    else:
                        self[tag]=value
        return

    def write(self):
        keys=self.keys()
        rx=re.compile("^\s*(?P<tag>\w+)\s*:(?P<value>.+)$",re.I)
        for line in self.lines:
            if line[0] != "#" and line[0] != ";":
                match=rx.search(line)
                if match != None:
                    tag=match.group("tag").strip()
                    if tag in self:
                        self.lines[self.lines.index(line)]="%-20s %s\n" % (tag +":",self[tag])
                        keys.remove(tag)
        for tag in keys:
            self.lines.append("%-20s %s\n" % (tag +":",self[tag]))
        
        if not os.path.isdir(os.path.dirname(HOME_FILE)):
            os.makedirs(os.path.dirname(HOME_FILE))
        fo=file(HOME_FILE,"w")
        fo.writelines(self.lines)
        fo.close()
        return
        
    def print_error(self,text):
        print text
        
    def set_error(self,error):
        self.error=error
