# GNU GPL

import pygtk
pygtk.require('2.0')
import gtk
import gobject

# The find dialog that filters gamelist
class Filter(gtk.Dialog):
    def __init__(self,config,parent):
        gtk.Dialog.__init__(self,title=_("Regular expression"), parent=parent, flags=gtk.DIALOG_MODAL, buttons=(gtk.STOCK_OK, gtk.RESPONSE_ACCEPT,
                      gtk.STOCK_CANCEL, gtk.RESPONSE_REJECT))
                      
        self.connect("key-press-event",self.key_press)
        box=gtk.HBox(False,10)
        titlesBox = gtk.VBox(False, 0)
        entriesBox = gtk.VBox(False, 0)
        box.pack_start(titlesBox, False, True, 0)
        box.pack_start(entriesBox, True, True, 0)

        # sets titles and entries box of dialog
        self.filter= dict()
        for entry in config["filters"]:
            textView=gtk.Label(_(entry.capitalize()))
            textView.set_alignment(1,0)
            titlesBox.pack_start(textView)
        
            self.filter[entry]=gtk.Entry()
            self.filter[entry].set_max_length(50)
            self.filter[entry].select_region(0, len(self.filter[entry].get_text()))
            entriesBox.pack_start(self.filter[entry], False, True, 0)
            
        self.vbox.pack_start(box, True, True, 10)
        self.show_all()

    def key_press(self,event,key):
        if gtk.gdk.keyval_name(key.keyval) == "Return":
            self.response(gtk.RESPONSE_ACCEPT)
        if gtk.gdk.keyval_name(key.keyval) == "Escape":
            self.response(gtk.RESPONSE_CANCEL)
        return

    # returns a dictionary with entries box values
    def get_values(self):
        pattern=dict()
        for entry in self.filter:
            pattern[entry]=self.filter[entry].get_text()
        return pattern
