# GNU GPL

import pygtk
pygtk.require('2.0')
import gtk
import gobject

class GamesListStore(gtk.ListStore):
    def __init__(self,config):
        self.config=config
        # FIXME : variable number of cols, this sucks
        eval_string="gtk.ListStore.__init__(self"
        for i in range(len(self.config["row_fields"])):
            eval_string=eval_string+",gobject.TYPE_STRING"
        eval_string=eval_string+",gobject.TYPE_STRING)"
        eval(eval_string)
        
        self.num_cols=len(self.config["row_fields"])

    # sets the list of games
    def set_list(self,match):
        for game in match:
            if match[game]["state"] not in self.config["hide_rows"]:
                line=list()
                for name in self.config["row_fields"]:
                    line.append(match[game][name])
                line.append(game)
                self.append(line)
    
    # sets selection class
    def set_selection(self,treeview):
        self.selectSelection=treeview.get_selection()
        self.selectSelection.set_mode(gtk.SELECTION_SINGLE)
        self.selectSelection.select_path(0)
        return

    # returns selected row
    def get_selection(self):
        (model,iter)=self.selectSelection.get_selected()
        if iter == None:
            return None
        return model.get_value(iter,self.num_cols)

class Games(gtk.ScrolledWindow):
    def __init__(self,config,start_xmame=None,select_game=None):
        gtk.ScrolledWindow.__init__(self)

        self.config=config

        self.treeview = gtk.TreeView()
        self.treeview.connect("row-activated",start_xmame)
        self.treeview.connect("cursor-changed",select_game)

        cell = gtk.CellRendererText()
        column=list()
        
        for col,name in enumerate(config["row_fields"]):
            column.append(gtk.TreeViewColumn(_(name.capitalize())))
            self.treeview.append_column(column[col])
            column[col].pack_start(cell, True)
            column[col].set_attributes(cell, text=col)
            column[col].set_sort_column_id(col)
            column[col].set_resizable(True)
            column[col].set_min_width(50)
        self.treeview.set_search_column(0)
        self.treeview.set_reorderable(True)
        self.treeview.set_enable_search(True)
        self.add(self.treeview)
        
        self.liststore = GamesListStore(self.config)
        self.treeview.set_model(self.liststore)
        self.liststore.set_selection(self.treeview)
        return

    # returns selected game
    def get_selection(self):
        return self.liststore.get_selection()

    # set the list of games
    def set_list(self,match):
        self.liststore = GamesListStore(self.config)
        self.treeview.set_model(self.liststore)
        self.liststore.set_selection(self.treeview)
        self.liststore.set_list(match)
        self.treeview.columns_autosize()
        col=self.treeview.get_column(0)
        self.treeview.set_cursor(0,col)
        self.treeview.grab_focus()
        return

    def set_focus(self):
        self.treeview.grab_focus()
        return
