# GNU GPL

import pango
import os
import os.path
import pygtk
pygtk.require('2.0')
import gtk
import gobject
import zipfile

# The inferior box where are the data and imagenes of the game.
class Show(gtk.HBox):
    def __init__(self,config):
        gtk.HBox.__init__(self,False,10)

        self.config=config
        self.set_size_request(-1,200)
        
        self.default_image=config["default_image"]
        self.image=gtk.Image()
        self.image.set_from_file(self.default_image)
        self.image.set_size_request(200,200)
        self.set_border_width(10)

        # load images
        self.load()
        
        self.titlesBox = gtk.VBox(False, 10)
        self.textView=dict()
        
        # define the labels that will shown game information
        attrs=pango.AttrList()
        attrs.insert(pango.AttrScale(pango.SCALE_XX_LARGE,0,100))
        attrs.insert(pango.AttrWeight(pango.WEIGHT_BOLD,0,100))
        self.titlesBox.pack_start(gtk.Label(),True,True,0)
        for entry in config["show"]:
            self.textView[entry]=gtk.Label()
            self.textView[entry].set_attributes(attrs)
            self.textView[entry].set_alignment(1,0)
            self.titlesBox.pack_start(self.textView[entry],False,True,0)
        self.titlesBox.pack_start(gtk.Label(),True,True,0)
        
        self.pack_start(self.titlesBox, True, True, 0)
        self.pack_start(self.image, False, True, 0)
        return

    # Load image sets
    def load(self):
        #
        # assign tuples to every image path.
        #  zip file tuple  => ( ZipFile class , set_image_from_zipfile function )
        #  directory tuple => ( directory     , set_image_from_directory function )
        #
        self.image_sets=list()
        for image_set in self.config["images"]:
            if zipfile.is_zipfile(image_set):
                self.image_sets.append((zipfile.ZipFile(image_set,"r"),
                                        self.set_image_from_zipfile))
            elif os.path.isdir(image_set):
                self.image_sets.append((image_set+"/",
                                        self.set_image_from_directory))
        return

    # Show the passed game
    def set_game(self,game):
        # set label texts
        for entry in self.config["show"]:
            self.textView[entry].set_text(game[entry])
        
        filename = game["rom"] + ".png"
        # set image from image sets
        for image_set,set_image_function in self.image_sets:
            if set_image_function(filename,image_set):
                break
        else:    
            self.image.set_from_file(self.default_image)
        return

    def set_image_from_directory(self,filename,directory):
        path=directory + filename
        if not os.access(path,os.R_OK):
            return False
        self.image.set_from_file(path)
        return True
    
    def set_image_from_zipfile(self,filename,zipfile):
        if filename not in zipfile.namelist():
            return False
        # FIXME : I don't know how set image from data 
        data = zipfile.read(filename)
        f = file("/tmp/temp"+str(os.getpid()),"w")
        f.write(data)
        f.close()
        self.image.set_from_file("/tmp/temp"+str(os.getpid()))
        return True
